/*******************************************************************************
 * CELLmicrocosmos 2.2 MembraneEditor (version 2.2.2_1)
 *
 * Copyright (c) 2005, 2014 The CELLmicrocosmos 2 Development Team
 *                          (Bjrn Sommer et al., Bielefeld University)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package org.cellmicrocosmos.cm2.engine;

import javax.vecmath.Point3f;

import org.cellmicrocosmos.cm2.dataobjects.Molecule_3D;
import org.cellmicrocosmos.cm2.membranepackingalgorithm.Molecule;

/**
 * A class that allows to execute code any time the user pressed the testbutton.
 * That way new developments can be tested without having them embedded into the
 * gui yet
 * 
 * @author Tim Dingersen dackelnose@gmx.net, Bjoern Sommer bjoern@CELLmicrocosmos.org
 * 
 */
public class TestArea {

	/**
	 * Has to be true in order to have access to the test button in the menu. If
	 * set to false, this button will be hidden. So if this class contains no
	 * tests, this flag should be set false.
	 */
	public static final boolean isActive =true;

	public static Engine engine;
	/**
	 * This method gets called when the test button got pressed
	 * 
	 * @throws Exception
	 */
	public static void execute() throws Exception {
		
		System.out.println("***TestArea***");
		System.out.println("This test class executes code in the test area: cm2_engine.TestArea.java\n");

//		Lipid_3D[]lips=DataPool.getMembraneModel().getAllExampleLipidsIntra().toArray(new Lipid_3D[0]);
//		for(int i=0;i<lips.length;i++) {
//			DataPool.getMembraneModel().deleteMolecule(lips[i]);
//		}
//		Molecule_3D[]mols = DataPool.getMembraneModel().getAllMoleculesInMembrane();
//		int c=5;
//		for(int i=0;i<mols.length;i++) {
//			c++;
//			if(c>=5)
//			{
//				c=0;
//				continue;
//			}
//			DataPool.getMembraneModel().deleteMolecule(mols[i]);
//		}
//engine.membraneview.getMembrane3D().repaintByMembraneModel(DataPool.getMembraneModel());
//engine.membraneOperations.refreshViews(true,true,true,true,true,true);
	
		
//#########################################################################################################		
		
//		Molecule_3D mol = DataPool.getMembraneModel().getAllMoleculesInMembrane()[0];
//		
//		Atom_3D[] atoms = mol.getAtoms(true,true);
//		
//		
//		int rand = new Random().nextInt(atoms.length);
//		
//		atoms[rand].position.scale(1.1f);
//		
//		mol.atoms[rand].color=Cm2_Toolkit.getRandomProteinColor();
//		
//		
////		atoms[rand].position.add(mol.getPosition());
//		
//		mol.applyAtomPosition(rand,atoms[rand].position);
//		
//		mol.updateGeometry();
		
		
		
//#########################################################################################################		
		
//		Molecule_3D mol = DataPool.getMembraneModel().getAllMoleculesInMembrane()[3];
//		
//		Atom[] atoms = mol.getAtoms(false,false);
//		
//		
//		
//		Vector<Atom>v = new Vector<Atom>();
////		mol.atoms[4].color=Color.GREEN;
//		v.addElement(mol.atoms[4]);
//		for(int i=0;i<mol.atoms[4].bondedNeighbors.size();i++) {
////			mol.atoms[4].bondedNeighbors.get(i).color=Color.GREEN;
//			v.addElement(mol.atoms[4].bondedNeighbors.get(i));
//		}
//		Particle p = new Particle(v.toArray(new Atom[0]));
//		p.color=Cm2_Toolkit.getRandomProteinColor();
//		mol.coarseGrain(p);
//		
//		
//
//		
//		mol.updateGeometry();
//		engine.membraneOperations.refreshViews(false,true,false,true,true,true);
		
//#########################################################################################################	
		
		
//		File input = new File("C:\\Dokumente und Einstellungen\\Dingii\\Cm2_Workspace\\Pdb_Files\\Frequently_Used_Lipids\\SPH1.pdb");
//		
//		PdbReader_3D reader = new PdbReader_3D();
//		
//		Lipid_3D mol = reader.readLipid(input,0,null);
//		
//		if(mol.getPDBcode()==null) {
//			mol.setPDBcode(Cm2_Toolkit.getSimpleName(mol.getPDBFile()));
//		}
//		MoleculeEditor editor = new MoleculeEditor(mol,true,engine,null);
		
		
		
		
		
		
//#########################################################################################################		
		

//		final Energies en = new Energies(null);
//		
//		System.out.println();
		
		
//		JFrame frame = new JFrame();
//
//		
//		GraphPanel gp = new GraphPanel("Steps","LJ System Free Energy","V(\u03b5)",new String[] {"Free Energy"},new Color[] {Color.orange});
//
//		gp.setPreferredSize(new Dimension(400,200));
//		frame.getContentPane().add(gp);
//		frame.pack();
//		frame.setLocationRelativeTo(null);
//		frame.setVisible(true);
//		
//		
//		
//			
//			int c=0;
//			Point2f[] ll = new Point2f[101];
//			for(float i=0.1f;i<10;i+=0.1f) {
//				Atom a = new Atom(null,null,0,null);
//				a.position=new Point3f(0,0,0);
//				
//				Atom b = new Atom(null,null,0,null);
//				b.position=new Point3f((float)i,0,0);
//				
//				float ljp = en.calculateLJPotential(a,b,5f);
//				ll[c]=new Point2f(i,ljp);
//				System.out.println(ll[c]);
//				if(i<1)System.out.println((int)ll[c].y);
//				c++;
//			}
//			
//
////			System.out.println(a.position.distance(b.position)+" <> "+e);
//			gp.setData(new Point2f[][] {ll});
		
		
		
/////////////////////////////////////////////////////////////////////////////////////		
		
//		JFrame frame = new JFrame();
//		ParameterMatrixPanel gui = new ParameterMatrixPanel(new String[] {"Blah","Blubb","Muh"},null,null);
//		
//		frame.getContentPane().add(gui);
//		frame.pack();
//		frame.setLocation(300,900);
//		frame.setVisible(true);
//		
		
		
		Molecule_3D mols = DataPool.getMembraneModel().getAllMoleculesInMembrane()[DataPool.getMembraneModel().getAllMoleculesInMembrane().length-1];
		if(mols.teporaryMolecule==null) {
		System.out.println(mols.getPosition());
		for(int i=mols.atoms.length-5;i<mols.atoms.length;i++) {
			
			System.out.println(i+" "+mols.atoms[i]);
			
		}
		System.out.println();
		}else {
		
		Molecule mol = DataPool.getMembraneModel().getAllMoleculesInMembrane()[DataPool.getMembraneModel().getAllMoleculesInMembrane().length-1].teporaryMolecule;
		System.out.println(mol.getPosition());
		for(int i=mol.getOriginalAtoms().length-8;i<mol.getOriginalAtoms().length;i++) {
			
			Point3f p = mol.getOriginalAtoms()[i].getPosition();
			p.add(mol.getOriginalAtoms()[i].getPosition());
			System.out.println(i+" "+p);
			
		}
		System.out.println();
		}
	}
	
	


}
