/*******************************************************************************
 * CELLmicrocosmos 2.2 MembraneEditor (version 2.2.2_1)
 *
 * Copyright (c) 2005, 2014 The CELLmicrocosmos 2 Development Team
 *                          (Bjrn Sommer et al., Bielefeld University)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *******************************************************************************/
package org.cellmicrocosmos.cm2.gui;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.lang.reflect.InvocationTargetException;
import java.net.MalformedURLException;
import java.net.URL;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Collections;
import java.util.Date;
import java.util.Vector;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.DefaultComboBoxModel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.ScrollPaneConstants;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumnModel;

import org.cellmicrocosmos.cm2.constants.CM2_CONSTANTS;
import org.cellmicrocosmos.cm2.engine.DataPool;
import org.cellmicrocosmos.cm2.engine.Engine;
import org.cellmicrocosmos.cm2.gui.dialogs.StatusDialog;
import org.cellmicrocosmos.cm2.interfaces.DatabaseViewListener;
import org.cellmicrocosmos.cm2.interfaces.SearchListener;
import org.cellmicrocosmos.cm2.io.FileIOHandler;
import org.cellmicrocosmos.cm2.io.ppe.toolbox.PPEUpdater;
import org.cellmicrocosmos.cm2.io.ppe.toolbox.PPE_CONSTANTS;
import org.cellmicrocosmos.cm2.misc.Cm2_IconDepot;
import org.cellmicrocosmos.cm2.misc.Cm2_Toolkit;
import org.cellmicrocosmos.cm2.misc.ConfigParser;


/**
 * A Gui that allows the User to search and to download Pdb Files via the RCSB
 * Database
 * 
 * @author Dingi dackelnose@gmx.net, Bjoern Sommer bjoern@CELLmicrocosmos.org
 * 
 */
public class GlobalDatabaseBrowser implements ActionListener,
		ListSelectionListener {
	// TODO dies ist die rcsb download seite
	final private JFrame frame = new JFrame() {
		private static final long serialVersionUID = 1L;
			public void dispose() {
				super.dispose();
				System.gc();
			}
	};

	final private JSplitPane split = new JSplitPane();

	final private MyJTable table = new MyJTable();

	final private JPanel ground = new JPanel();

	final private JPanel p1 = new JPanel();

	final private JPanel p2 = new JPanel();

	final private JPanel p3 = new JPanel();

	final private JPanel p4 = new JPanel();

	final private JPanel p11 = new JPanel();

	final private JPanel p12 = new JPanel();

	final private JPanel p21 = new JPanel();

//	final private JPanel p22 = new JPanel();

	final private JPanel p31 = new JPanel();

	final private JPanel p32 = new JPanel();
	
	final private JPanel p33 = new JPanel();

	final private JPanel p41 = new JPanel();

	final private JButton btn1 = new JButton("Search");
	
	final private JRadioButton rbOr=new JRadioButton("OR");
	
	final private JRadioButton rbAnd=new JRadioButton("AND");

	final private JButton btn2 = new JButton("Update PDB");

	final private JButton btn3 = new JButton("Download PDB");

	final private JButton btn4 = new JButton();

	final private JButton btn5 = new JButton("Close");

	final private JButton btn6 = new JButton("Update PDBTM");
	
	final private JButton btn7 = new JButton("Update OPM");
	
	final private JButton btn8 = new JButton("Download OPM");

	final private JComboBox combo1 = new JComboBox();

	final private JScrollPane scroll1;

	final private JTextField tf1 = new JTextField();

	final private JTextField tf2 = new JTextField();
	
	final private JTextField tf3 = new JTextField();

	final private JCheckBox check1 = new JCheckBox();

	final private JLabel l1 = new JLabel();

	final private JLabel l2 = new JLabel();

	final private JLabel l3 = new JLabel();

	final private JLabel l4 = new JLabel();
	
	final private JLabel l5 = new JLabel();

	final private JLabel l6 = new JLabel();
	
	final private JLabel l7 = new JLabel();

	final private JLabel l8 = new JLabel();

	final private JPanel p1000 = new JPanel();

	final private JLabel tablebar = new JLabel("", SwingConstants.LEADING);

	final private JPanel p1001 = new JPanel();

	private DatabaseViewListener listener;

	private URL rcsbEntriesLink;

	private String rcsbDownloadLink;
	
	private String opmDownloadLink;

	// Path for the entries file
	private File contentsFile = CM2_CONSTANTS.IO.ENTRIES_FILE;

	private File contentsBackupFile;

	private final DefaultComboBoxModel combomodel = new DefaultComboBoxModel();

	private BufferedReader streamreader = null;

	private BufferedWriter filewriter = null;

	private boolean sortUpwards = true;

	private final JPanel picpanel = new JPanel();

	private final JLabel piclabel = new JLabel();

	private final JButton openBrowser = new JButton();

	Thread t = null;

	private Object code;

	ImageThread imageThread;

	
	/**
	 * Constructs and shows the Gui
	 * 
	 */
	@SuppressWarnings("serial")
	public GlobalDatabaseBrowser(String searchString, String searchTitle) {

		this.setContentsFile(CM2_CONSTANTS.IO.ENTRIES_FILE);
		PPEUpdater.setContentsFile(PPE_CONSTANTS.DB.PDBTM,l2);
		PPEUpdater.setContentsFile(PPE_CONSTANTS.DB.OPM,l3);
		
		this.doSettings();

		this.frame.setIconImage(Cm2_IconDepot.getSpecifiedIcon("DB_Rcsb")
				.getImage());
		this.frame.setTitle("Download a PDB"+searchTitle);
		this.frame.addWindowListener(this.createWindowListener());

		JScrollPane scrollMain = new JScrollPane(this.split);
		scrollMain.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		scrollMain.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
		
		this.frame.getContentPane().add(scrollMain);

		this.scroll1 = new JScrollPane(this.table);

		this.split.setLeftComponent(this.p1000);
		this.split.setRightComponent(this.ground);
		this.split.setEnabled(true);

		this.ground.setLayout(new BoxLayout(this.ground, BoxLayout.Y_AXIS));
		this.p1.setLayout(new BoxLayout(this.p1, BoxLayout.Y_AXIS));
		this.p2.setLayout(new BoxLayout(this.p2, BoxLayout.Y_AXIS));
		this.p3.setLayout(new BoxLayout(this.p3, BoxLayout.Y_AXIS));
		this.p4.setLayout(new BoxLayout(this.p4, BoxLayout.Y_AXIS));
		this.p1000.setLayout(new BoxLayout(this.p1000, BoxLayout.Y_AXIS));

		this.p21.setLayout(new GridLayout(4, 3));

		this.combo1.setFont(new Font(this.combo1.getFont().getFontName(),
				Font.PLAIN, this.combo1.getFont().getSize() + 3));
		this.tf1.setFont(new Font(this.tf1.getFont().getFontName(),
				Font.ITALIC, this.tf1.getFont().getSize()));
		this.tf2.setFont(this.tf1.getFont());
		this.tf3.setFont(this.tf1.getFont());

		this.btn2.setFont(new Font(this.btn2.getFont().getFontName(),
				Font.PLAIN, this.btn2.getFont().getSize() - 1));
		this.btn6.setFont(new Font(this.btn2.getFont().getFontName(),
				Font.PLAIN, this.btn2.getFont().getSize() - 1));
		this.btn7.setFont(new Font(this.btn2.getFont().getFontName(),
				Font.PLAIN, this.btn2.getFont().getSize() - 1));

		ButtonGroup bg = new ButtonGroup();
		bg.add(rbAnd);
		bg.add(rbOr);
		rbOr.setSelected(true);
		this.p1000.add(this.scroll1);
		this.p1000.add(this.p1001);

		this.p1001.add(this.tablebar);

		this.ground.add(this.p2);
		this.ground.add(this.p1);
		this.ground.add(this.picpanel);

		this.ground.add(new JPanel());
		this.ground.add(this.p3);
		this.ground.add(this.p4);
		final JPanel pp = new JPanel();
		pp.setLayout(new BoxLayout(pp, BoxLayout.X_AXIS));
		this.ground.add(pp);
		pp.add(Box.createHorizontalGlue());
		pp.add(this.btn5);
		pp.add(Box.createHorizontalGlue());
		pp.add(new HelpBtn(this));
		pp.add(Box.createHorizontalStrut(5));

		this.picpanel.setLayout(new BoxLayout(this.picpanel, BoxLayout.Y_AXIS));
		final JPanel jpl = new JPanel();
		final JPanel jpl2 = new JPanel();

		jpl.add(this.piclabel);
		jpl2.add(this.openBrowser);
		this.picpanel.add(jpl);
		this.picpanel.add(jpl2);
		this.openBrowser.addActionListener(this);
		this.openBrowser.setEnabled(false);
		this.openBrowser
				.setToolTipText("Display more information about this type at the RCSB homepage");

		this.picpanel.setBorder(BorderFactory.createTitledBorder("Preview"));
		this.piclabel.setBorder(BorderFactory.createEtchedBorder());
		this.openBrowser.setIcon(new ImageIcon(Toolkit.getDefaultToolkit()
				.createImage(
						FileIOHandler.home + "cm2images" + File.separator
								+ "RCSB_Icon.JPG")));

		this.p11.add(this.combo1);
		this.p11.add(this.btn1);
		this.p1.add(this.p11);
		this.p1.add(this.p12);
		this.p12.add(rbAnd);
		this.p12.add(rbOr);

		this.p21.add(this.btn2);
		this.p21.add(this.btn6);
		this.p21.add(this.btn7);
		this.p21.add(this.l1);
		this.p21.add(this.l2);
		this.p21.add(this.l3);
		this.p21.add(this.l4);
		this.p21.add(this.l5);
		this.p21.add(this.l6);
		this.p21.add(this.l7);
		this.p21.add(this.l8);
		this.p21.add(new HelpBtn(this));
		
		this.l7.setText("");
		this.l8.setText("Info & Citations:");
		
//		this.p22.add(this.btn2);
//		this.p22.add(this.btn6);
//		this.p22.add(this.btn7);

		this.p2.add(this.p21);
//		this.p2.add(this.p22);

//		this.p22.setAlignmentX(Component.RIGHT_ALIGNMENT);

		this.p31.add(this.tf1);
		this.p32.add(this.tf2);
		this.p33.add(this.tf3);

		this.p3.add(this.p31);
		this.p3.add(this.p32);
		this.p3.add(this.p33);

		this.p33.add(this.btn4);

		this.p41.add(this.btn3);
		this.p41.add(this.btn8);
		this.p41.add(this.check1);
		this.p4.add(this.p41);

		this.btn1.addActionListener(this);
		this.btn2.addActionListener(this);
		this.btn3.addActionListener(this);
		this.btn4.addActionListener(this);
		this.btn5.addActionListener(this);
		this.btn6.addActionListener(this);
		this.btn7.addActionListener(this);
		this.btn8.addActionListener(this);

		this.combo1.setEditable(true);
		this.combo1.setMaximumRowCount(8);
		this.combo1.setModel(this.combomodel);

		this.tf1.setEditable(false);
		this.tf2.setEditable(false);
		this.tf3.setEditable(false);

		this.btn4.setIcon(Cm2_IconDepot.getSpecifiedIcon("Folder_Plain"));

		this.btn1.setToolTipText("Start a search on the terms you entered");
		this.btn2
				.setToolTipText("<html>Updates the entries file that is used for searching.<br>"
						+ "This may take a few seconds!</html>");
		this.btn3
				.setToolTipText("Download the PDB file for the selected match");
		this.btn4.setToolTipText("Change the directory for incoming files");
		this.btn6
				.setToolTipText("<html>Updates the entries file that is used for the PDBTM matrices.<br>"
						+ "This may take a few seconds!</html>");
		this.btn7
				.setToolTipText("<html>Updates the entries file that is used for the OPM data.<br>"
				+ "This may take a few seconds!</html>");
		this.btn8
				.setToolTipText("Download the OPM file for the selected match");
		this.combo1
				.setToolTipText("<html>Enter a search term here or select a previous one.<br>"
						+ "You can enter multiple terms by dividing them with [space].<br>"
						+ "The logic operation used then is AND</html>");

		this.check1
				.setToolTipText("<html>If true, file gets added to the current local database<br>"
						+ "when the download is finished</html>");

		this.scroll1.setBorder(BorderFactory
				.createTitledBorder("Search Results"));

		this.table.setModel(new DefaultTableModel() {
			public boolean isCellEditable(final int row, final int column) {
				return false;
			}
		});
		if (Engine.getMRNA()!=null)
			((DefaultTableModel) this.table.getModel())
					.setColumnIdentifiers(new String[] { "Code", "PDBTM", "OPM", "Header",
							"Description", "Species", "Date", "E.C." });
		else
			((DefaultTableModel) this.table.getModel())
			.setColumnIdentifiers(new String[] { "Code", "PDBTM", "OPM", "Header",
					"Description", "Species", "Date"});
	
		this.table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		this.table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		this.table.getTableHeader().setReorderingAllowed(false);

		this.table.getTableHeader()
				.addMouseListener(this.createMouseListener());
		this.table.addMouseListener(this.createMouseListener());

		for (int i = 0; i < this.table.getColumnCount(); i++) {
			if (i==1) {
				this.table.getColumnModel().getColumn(1).setCellRenderer(new TableCellRenderer() {
					public Component getTableCellRendererComponent(final JTable table,
							final Object color, final boolean isSelected,
							final boolean hasFocus, final int row, final int column) {
						final JLabel label = new JLabel();
						if (table.getValueAt(row, column).toString().equals("true")) {
							label.setIcon(Cm2_IconDepot.getSpecifiedIcon("DB_PDBTM"));
						}
						return label;
					}
				});
			} else if (i==2) {
				this.table.getColumnModel().getColumn(2).setCellRenderer(new TableCellRenderer() {
					public Component getTableCellRendererComponent(final JTable table,
							final Object color, final boolean isSelected,
							final boolean hasFocus, final int row, final int column) {
						final JLabel label = new JLabel();
						if (table.getValueAt(row, column).toString().equals("true")) {
							label.setIcon(Cm2_IconDepot.getSpecifiedIcon("DB_OPM"));
						}
						return label;
					}
				});
			} else
				this.table.getColumnModel().getColumn(i).setCellRenderer(
						new DefaultTableCellRenderer());
		}
	
		this.p1.setBorder(BorderFactory.createTitledBorder("Search"));
		this.p2.setBorder(BorderFactory.createTitledBorder("Contents"));
		this.p4.setBorder(BorderFactory.createTitledBorder("Download"));

//		this.l1.setText("Entries file:");
//		this.l3.setText("Last Updated:");
		
		this.tablebar
				.setText("In order to search, enter one or more terms into the search Box");

		this.combo1.setBorder(BorderFactory.createLoweredBevelBorder());

		this.p31.setBorder(BorderFactory.createTitledBorder("PDB Download Link"));
		this.p32.setBorder(BorderFactory.createTitledBorder("OPM Download Link"));
		this.p33.setBorder(BorderFactory.createTitledBorder("Incoming Folder"));

		this.check1.setText("add to Database");
		this.check1.setSelected(true);

		this.pack();

		this.table.getColumnModel().getColumn(0).setPreferredWidth(50);
		this.table.getColumnModel().getColumn(1).setPreferredWidth(35);
		this.table.getColumnModel().getColumn(2).setPreferredWidth(35);
		this.table.getColumnModel().getColumn(3).setPreferredWidth(250);
		this.table.getColumnModel().getColumn(4).setPreferredWidth(600);
		this.table.getColumnModel().getColumn(5).setPreferredWidth(400);
		this.table.getColumnModel().getColumn(6).setPreferredWidth(50);
		if (Engine.getMRNA()!=null)
			this.table.getColumnModel().getColumn(7).setPreferredWidth(50);

		this.frame.setVisible(true);

		if (this.contentsFile.exists() == false) {
			if (JOptionPane
					.showConfirmDialog(
							this.frame,
							"The file that contains the entries is missing or does not exist yet.\n"
									+ "This file is needed for the search function.\n\n"
									+ "Do you want to download it now?",
							"No Contents-File found",
							JOptionPane.YES_NO_OPTION,
							JOptionPane.INFORMATION_MESSAGE) == JOptionPane.YES_OPTION)
				this.performUpdate();

		}
		
		if (!searchString.isEmpty() && !searchString.equals("null")) {
			this.combo1.setSelectedItem(searchString);		
			this.btn1.doClick();
		}

	}

	/**
	 * Sets the Gui and its Components to proper size
	 * 
	 */
	private void pack() {

		final Dimension screen = this.frame.getToolkit().getScreenSize();

		final int x = (int) (screen.width * CM2_CONSTANTS.GUI_SETTINGS_AND_CONTROLS.PDBSEARCH_FRAME_SCALE);
		final int y = (int) (screen.height
				* CM2_CONSTANTS.GUI_SETTINGS_AND_CONTROLS.PDBSEARCH_FRAME_SCALE * 1.25f);

		this.scroll1.setPreferredSize(new Dimension(x - x / 5, y - y / 4));
		this.tablebar.setPreferredSize(new Dimension(x - x / 4, 10));
		this.combo1.setPreferredSize(new Dimension(x / 5, 25));
		this.tf1.setPreferredSize(new Dimension(x / 4, 20));
		this.tf2.setPreferredSize(new Dimension(x / 4, 20));
		this.tf3.setPreferredSize(new Dimension(x / 4
				- this.btn4.getPreferredSize().width - 2, 20));
		this.picpanel.setPreferredSize(new Dimension(205, 260));
		this.piclabel.setPreferredSize(new Dimension(200, 200));
		this.frame.pack();
		this.frame.setLocation(screen.width / 2 - this.frame.getWidth() / 2,
				screen.height / 2 - this.frame.getHeight() / 2);
	}

	/**
	 * Returns the Sizes of each Column in an Array
	 * 
	 * @return
	 */
	private int[] getColumnSizes() {

		final TableColumnModel model = this.table.getColumnModel();
		final int[] ints = new int[model.getColumnCount()];
		for (int i = 0; i < model.getColumnCount(); i++) {

			ints[i] = model.getColumn(i).getWidth();
		}
		return ints;
	}

	/**
	 * Sets the size of each Column according to the passed ints
	 * 
	 * @param ints
	 */
	private void setColumnSizes(final int[] ints) {

		final TableColumnModel model = this.table.getColumnModel();
		for (int i = 0; i < ints.length; i++) {
			if (model.getColumn(i) != null)
				model.getColumn(i).setPreferredWidth(ints[i]);
		}

	}

	/**
	 * Adds a DatabaseListener to this Instance
	 * 
	 * @param listener
	 */
	public void setDatabaseViewListener(final DatabaseViewListener listener) {
		this.listener = listener;
	}

	/**
	 * Creates a WindowListener that saves the search History to Config
	 * 
	 * @return
	 */
	private WindowListener createWindowListener() {

		return new WindowAdapter() {

			public void windowClosing(final WindowEvent arg0) {

				ConfigParser.deleteAllAt("search_strings");
				for (int i = 0; i < GlobalDatabaseBrowser.this.combomodel
						.getSize(); i++) {

					ConfigParser.addValue("search_strings",
							GlobalDatabaseBrowser.this.combomodel.getElementAt(
									i).toString());
				}
				if (GlobalDatabaseBrowser.this.listener != null)
					GlobalDatabaseBrowser.this.listener
							.userClosesGlobalDBView();

			}

		};
	}

	/**
	 * Creates a customized MouseListener for the tables
	 * 
	 */
	private MouseListener createMouseListener() {

		return new MouseAdapter() {

			@SuppressWarnings("unchecked")
			public void mouseClicked(final MouseEvent arg0) {

				if (arg0.getSource() instanceof JTableHeader) {
					// sorts the column the user clicked
					if (arg0.getSource() == GlobalDatabaseBrowser.this.table
							.getTableHeader()) {

						if (arg0.getButton() != MouseEvent.BUTTON1)
							return;

						final int colnumber = GlobalDatabaseBrowser.this.table
								.getTableHeader()
								.columnAtPoint(arg0.getPoint());

						final Vector data = ((DefaultTableModel) GlobalDatabaseBrowser.this.table
								.getModel()).getDataVector();

						// Limiting sorting for dates because of experienced
						// trouble
						// with very large numbers
						if ((colnumber == 6 && ((DefaultTableModel) GlobalDatabaseBrowser.this.table
								.getModel()).getRowCount() > 500) == false) {

							// sorting the data in the table
							Collections.sort(data, new MyColumnSorter(
									colnumber,
									GlobalDatabaseBrowser.this.sortUpwards));
						}

						final int[] colsizes = GlobalDatabaseBrowser.this
								.getColumnSizes();
						((DefaultTableModel) GlobalDatabaseBrowser.this.table
								.getModel()).fireTableStructureChanged();

						GlobalDatabaseBrowser.this.setColumnSizes(colsizes);
						GlobalDatabaseBrowser.this.sortUpwards = !GlobalDatabaseBrowser.this.sortUpwards;
					}
				}
				if (arg0.getSource() instanceof JTable) {

					final JTable table = (JTable) arg0.getSource();
					if (arg0.getButton() == MouseEvent.BUTTON1) {
						
						btn8.setEnabled(table.getValueAt(table.getSelectedRow(), 2).toString().equals("true"));
						if (arg0.getClickCount() > 1) {

//							if (table.getSelectedColumn() == 0)
//								return;
//							
							if (table.getSelectedColumn() == 2) {
								if (table.getValueAt(table.getSelectedRow(), 2).toString().equals("true"))
									GlobalDatabaseBrowser.this.performDownload(true);
							} else {
								GlobalDatabaseBrowser.this.performDownload(false);
							}
						}
					}
				}
			}
		};

	}

	/**
	 * Sets up all values according to the Config
	 * 
	 */
	private void doSettings() {

		try {
			this.rcsbEntriesLink = new URL(
					DataPool.InternetSettings.rcsbentriesLink);
		} catch (final Throwable e) {

		}

		this.rcsbDownloadLink = DataPool.InternetSettings.rcsbdownloadLink;
		
		this.opmDownloadLink = DataPool.InternetSettings.opmdownloadLink;

		String[] strings = new String[0];

		try {
			strings = ConfigParser.getValue("search_strings");
		} catch (final Throwable e) {
			// combobox will remain empty
		}

		for (int i = 0; i < strings.length; i++) {
			this.combomodel.addElement(strings[i]);
		}

		this.combo1.addActionListener(this);
		this.updateLastModified();

		try {
			File filepath;

			filepath = new File(
					ConfigParser.getValue("incoming_Pdb_directory")[0]);

			// checks if the retrieved file is a valid directory
			if (!filepath.exists() || !filepath.isDirectory())
				throw new Exception();

			// ...and if so sets the filechoosers path
			this.tf3.setText(filepath.getPath());
			this.tf3.setToolTipText(filepath.getPath());

		} catch (final Exception e) {

			// setting the default paths
			if (DataPool.IO.DEFAULTINCOMINGDIRECTORY.exists())
				this.tf3
						.setText(DataPool.IO.DEFAULTINCOMINGDIRECTORY.getPath());
			this.tf3.setToolTipText(DataPool.IO.DEFAULTINCOMINGDIRECTORY
					.getPath());

		}

	}

	/**
	 * Sets the file for the Entries
	 * 
	 * @param file
	 */
	public void setContentsFile(final File file) {
		this.contentsFile = file;
		// setting the backupfile, too
		this.contentsBackupFile = new File(file.getPath() + "_backup");

		if (this.contentsFile.exists()) {
			this.l1.setText(this.contentsFile.getName());
			this.l1.setToolTipText(this.contentsFile.getAbsolutePath());
		} else {
			this.l1.setText("-");
		}
	}

	/**
	 * Catches ButtonClicks
	 */
	public void actionPerformed(final ActionEvent arg0) {

		if (arg0.getSource() == this.openBrowser) {
			if (this.code != null)
				Cm2_Toolkit
						.openWebPageOnSystemBrowser(DataPool.InternetSettings.rcsbLink
								.replaceAll("#PDBCODE#", (String) this.code));
		}

//		if (arg0.getSource() == this.combo1) {
//
//			if (this.t == null)
//				this.btn1.doClick();
//			else if (this.t.isAlive() == false) {
//				this.btn1.doClick();
//
//			}
//		}

		// Starts searching plus updating the combobox on new search Strings
		if (arg0.getSource() == this.btn1) {

			if (this.combo1.getSelectedItem() == null)
				return;
			else if (this.combo1.getSelectedItem().toString().length() < 1)
				return;

			final String searchstring = this.combo1.getSelectedItem()
					.toString();
			if (searchstring.length() < 1)
				return;

			this.enable(false);

			final int indexof = this.combomodel.getIndexOf(searchstring);

			if (indexof != -1) {

				this.combomodel.removeElementAt(indexof);
				this.combomodel.insertElementAt(searchstring, 0);
				this.combomodel.setSelectedItem(searchstring);

			} else {
				if (this.combomodel.getSize() > CM2_CONSTANTS.GUI_SETTINGS_AND_CONTROLS.MAX_PDB_SEARCH_HISTORY_SIZE) {
					this.combomodel
							.removeElementAt(this.combomodel.getSize() - 1);
				}
				this.combomodel.insertElementAt(searchstring, 0);
				this.combomodel.setSelectedItem(searchstring);
			}

			this.performSearch(searchstring);

		}
		// starts updating
		if (arg0.getSource() == this.btn2) {
			this.performUpdate();
		}
		// start to download the PDB of the current selection
		if (arg0.getSource() == this.btn3) {
			this.performDownload(false);
		}
		// Opens a filechooser where the incoming folder can be changed
		if (arg0.getSource() == this.btn4) {

			final JFileChooser fc = new JFileChooser();

			// make sure user can only apply having ONE NON-DIRECTORY PDB file
			// selected
			fc.setMultiSelectionEnabled(false);
			fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
			fc.setAcceptAllFileFilterUsed(false);

			try {
				File filepath;

				filepath = new File(ConfigParser
						.getValue("incoming_Pdb_directory")[0]);

				// checks if the retrieved file is a valid directory
				if (!filepath.exists() || !filepath.isDirectory())
					throw new Exception();

				// ...and if so sets the filechoosers path
				fc.setCurrentDirectory(filepath.getAbsoluteFile());

			} catch (final Exception e) {

				// setting the default paths
				if (DataPool.IO.DEFAULTINCOMINGDIRECTORY.exists())
					fc.setCurrentDirectory(DataPool.IO.DEFAULTINCOMINGDIRECTORY
							.getAbsoluteFile());

			}

			fc.setDialogTitle("Change Incoming Folder");

			final int val = fc.showOpenDialog(this.frame);

			if (val == JFileChooser.APPROVE_OPTION) {
				final File file = fc.getSelectedFile();

				// storing the new Path
				ConfigParser.deleteAllAt("incoming_Pdb_directory");
				ConfigParser.addValue("incoming_Pdb_directory", file.getPath());

				this.tf3.setText(file.getPath());
				this.tf3.setToolTipText(file.getPath());
			}

		}
		if (arg0.getSource() == this.btn5) {
			this.frame.getWindowListeners()[0].windowClosing(null);

			this.frame.dispose();
		}
		// starts updating the PDBTM
		if (arg0.getSource() == this.btn6) {
			if (PPEUpdater.lookUpForUpdates(PPE_CONSTANTS.DB.PDBTM)) {
				PPEUpdater.makeUpdate(PPE_CONSTANTS.DB.PDBTM);
				this.updateLastModified();
			} else {
				JOptionPane.showMessageDialog(null,
						"PDBTM Update is not necessary.", "PDBTM Update",
						JOptionPane.PLAIN_MESSAGE);
			}
		}
		// starts updating the OPM
		if (arg0.getSource() == this.btn7) {
			if (PPEUpdater.lookUpForUpdates(PPE_CONSTANTS.DB.OPM)) {//for OPM always true here
				PPEUpdater.makeUpdate(PPE_CONSTANTS.DB.OPM);
				this.updateLastModified();
			}
		}
		// start to download the OPM-PDB of the current selection
		if (arg0.getSource() == this.btn8) {

			this.performDownload(true);

		}


	}

	/**
	 * Starts to download the entries file in a new Thread
	 * 
	 */
	private void performUpdate() {
		final JButton cncl = new JButton("Cancel");

		final StatusDialog dia = new StatusDialog(cncl, true);

		final Thread t = new Thread() {
			public void run() {

				final boolean done = GlobalDatabaseBrowser.this
						.updateEntriesFile(dia);
				try {
					if (GlobalDatabaseBrowser.this.streamreader != null)
						GlobalDatabaseBrowser.this.streamreader.close();
					if (GlobalDatabaseBrowser.this.filewriter != null)
						GlobalDatabaseBrowser.this.filewriter.close();
				} catch (final Exception e) {
					e.printStackTrace();
				}

				dia.dispose();
				GlobalDatabaseBrowser.this.enable(true);
				if (done) {
					GlobalDatabaseBrowser.this.contentsBackupFile.delete();

					GlobalDatabaseBrowser.this.l2
							.setText(GlobalDatabaseBrowser.this.contentsFile
									.getName());
					GlobalDatabaseBrowser.this.l2
							.setToolTipText(GlobalDatabaseBrowser.this.contentsFile
									.getAbsolutePath());
					GlobalDatabaseBrowser.this.contentsFile
							.setLastModified(System.currentTimeMillis());
					GlobalDatabaseBrowser.this.updateLastModified();

				} else {
					if (GlobalDatabaseBrowser.this.contentsBackupFile.exists()) {
						GlobalDatabaseBrowser.this.contentsFile.delete();
						GlobalDatabaseBrowser.this.contentsBackupFile
								.renameTo(GlobalDatabaseBrowser.this.contentsFile);
					}
				}
			}

		};

		cncl.addActionListener(new ActionListener() {

			@SuppressWarnings("deprecation")
			public void actionPerformed(final ActionEvent arg0) {

				t.stop();

				try {
					if (GlobalDatabaseBrowser.this.streamreader != null)
						GlobalDatabaseBrowser.this.streamreader.close();
					if (GlobalDatabaseBrowser.this.filewriter != null)
						GlobalDatabaseBrowser.this.filewriter.close();
				} catch (final IOException e) {
					e.printStackTrace();
				}

				if (GlobalDatabaseBrowser.this.contentsBackupFile.exists()) {
					GlobalDatabaseBrowser.this.contentsFile.delete();
					GlobalDatabaseBrowser.this.contentsBackupFile
							.renameTo(GlobalDatabaseBrowser.this.contentsFile);
				}

				dia.dispose();
				GlobalDatabaseBrowser.this.enable(true);

			}

		});
		this.enable(false);
		t.setPriority(Thread.MIN_PRIORITY);
		t.start();

	}

	/**
	 * En or Disables the gui
	 * 
	 * @param b
	 */
	private void enable(final boolean b) {

		this.btn1.setEnabled(b);
		this.btn2.setEnabled(b);
		this.btn3.setEnabled(b);
		this.btn6.setEnabled(b);
		this.btn7.setEnabled(b);
		this.btn8.setEnabled(b);
		this.combo1.setEnabled(b);
		this.check1.setEnabled(b);

		this.combo1.removeActionListener(this);
		if (b)
			this.combo1.addActionListener(this);
	}

	/**
	 * Literally performs the download; Gets run in a seperate Thread
	 * 
	 * @param dia
	 * @return true, if sucessful, false otherwise
	 */
	private boolean updateEntriesFile(final StatusDialog dia) {
		this.streamreader = null;
		this.filewriter = null;

		dia.setProgress("Establishing Connection...", 0, true);

		try {

			this.streamreader = new BufferedReader(new InputStreamReader(
					this.rcsbEntriesLink.openStream()));

		} catch (final Throwable e) {
			JOptionPane
					.showMessageDialog(
							this.frame,
							"Problems occured while trying to establish connection to the following link:\n\n"
									+ (this.rcsbEntriesLink != null ? this.rcsbEntriesLink
											.toExternalForm()
											: "Blank")
									+ "\nPlease check the connection on your computer\n"
									+ "and Settings -> Connection in CmME."
									+ "\nProbably the Proxy settings are wrong."
									+ "\n\nReason:\n"
									+ e.toString(), "Connection Failed",
							JOptionPane.ERROR_MESSAGE);

			return false;
		}

		try {
			if (new File(this.contentsFile.getParent()).exists() == true) {
				final File tmp = new File(this.contentsFile.getParent());
				if (tmp.exists() == false && tmp.mkdirs() == false)
					throw new IOException("The directory " + tmp.getPath()
							+ " cannot be created!");
			}
			if (this.contentsFile.exists()) {
				this.contentsBackupFile.delete();
				if (this.contentsFile.renameTo(this.contentsBackupFile) == false)
					throw new IOException("The old file is protected");
			}
			this.filewriter = new BufferedWriter(new FileWriter(
					this.contentsFile));

			this.readwrite(dia, null);

		} catch (final Throwable e) {
			JOptionPane.showMessageDialog(this.frame, "Cannot write the file\n"
					+ this.contentsFile.getPath() + "\n\nReason:\n"
					+ e.toString(), "Error", JOptionPane.ERROR_MESSAGE);

			return false;
		}

		return true;

	}

	private void readwrite(final StatusDialog dia, final File dest)
			throws Throwable {
		int size = -1;
		if (dest == null) {

			try {
				final BufferedReader buff = new BufferedReader(
						new InputStreamReader(new URL(
								"http://www.rcsb.org/pdb/home/home.do")
								.openStream()));

				while (true) {
					final String ln = buff.readLine();
					if (ln == null)
						break;
					if (ln.contains("there are") && ln.contains("Structures")) {

						final String[] strings = ln.trim().split(" ");

						try {

							size = Integer.parseInt(strings[2].trim());

						} catch (final Exception e) {

						}
						break;
					}
				}
			} catch (final Throwable e) {
				size = -1;
			}
		}

		int counter = 0;
		int lines = 1;
		final int limit = dest == null ? 250 : 100;
		while (true) {

			final String line = this.streamreader.readLine();
			lines++;
			counter++;
			if (line == null)
				break;

			this.filewriter.write(line);

			this.filewriter.newLine();

			if (counter > limit) {
				counter = 0;

			} else
				continue;

			if (dest == null) {
				if (size > 0) {

					final int value = (int) ((100f / (float) size) * lines);

					dia.setProgress("<html>Updating...<br><br>Completed: "
							+ lines + " of " + size + " entries"
							+ "<br></html>", value, true);
				} else {
					dia
							.setProgress("<html>Updating...<br><br>Completed: "
									+ lines + " of " + "?" + " entries"
									+ "<br></html>", 0, true);
				}
			} else {
				dia.setProgress("<html>Downloading<br><br>" + dest.getName()
						+ "<br><br>Completed: "
						+ Cm2_Toolkit.convertFileSizeToString(dest.length())

						+ "<br> <br> </html>", 0, true);
			}
		}
	}

	/**
	 * Starts the search Thread where the passed string is used as the
	 * searchword
	 * 
	 * @param searchstring
	 */
	private void performSearch(final String searchstring) {
		if (this.contentsFile.exists() == false) {
			if (JOptionPane
					.showConfirmDialog(
							this.frame,
							"The file that contains the entries is missing or does not exist yet.\n"
									+ "This file is needed for the search function.\n\n"
									+ "Do you want to download it now?",
							"No Contents-File found",
							JOptionPane.YES_NO_OPTION,
							JOptionPane.INFORMATION_MESSAGE) == JOptionPane.YES_OPTION) {
				this.performUpdate();
				return;
			} else
				return;

		}

		final Searcher searcher = new Searcher();
		final JButton stop = new JButton("Stop");
		final StatusDialog dialog = new StatusDialog(stop, true);

		this.t = new Thread() {
			public void run() {

				GlobalDatabaseBrowser.this.tf1.setText("");
				GlobalDatabaseBrowser.this.tf1.setToolTipText("");
				GlobalDatabaseBrowser.this.tf2.setText("");
				GlobalDatabaseBrowser.this.tf2.setToolTipText("");
				GlobalDatabaseBrowser.this.openBrowser.setEnabled(false);
				GlobalDatabaseBrowser.this.code = null;
				GlobalDatabaseBrowser.this.piclabel.setIcon(null);
				// updateImage();
				final DefaultTableModel model = (DefaultTableModel) GlobalDatabaseBrowser.this.table
						.getModel();

				model.setRowCount(0);

				int length = 0;

				try {
					searcher.prepareLength();
					length = searcher.length;
					if (length < 1)
						throw new Exception("File seems to be empty");
				} catch (final Exception e) {
					JOptionPane.showMessageDialog(
							GlobalDatabaseBrowser.this.frame,
							"Unable to read the entries file.\n"
									+ "\nReason:\n" + e.toString() + "\n\n"
									+ "Please restore this file first",
							"Error", JOptionPane.ERROR_MESSAGE);

				}
				if (length > 0) {
					dialog.setProgress("Searching ( 0 / " + length + " )", 0,
							true);
					try {
						searcher.startSearching(searchstring, rbOr.isSelected());
					} catch (final Exception e) {
						JOptionPane
								.showMessageDialog(
										GlobalDatabaseBrowser.this.frame,
										"An Error occured during search.\n"
												+ "The entries file is probably malformed"
												+ "\nReason:\n" + e.toString()
												+ "\n\n", "Error",
										JOptionPane.ERROR_MESSAGE);
						searcher.close();
					}

				}

				GlobalDatabaseBrowser.this.enable(true);
				dialog.dispose();
				searcher.close();

				((ListSelectionModel) GlobalDatabaseBrowser.this.table
						.getSelectionModel())
						.addListSelectionListener(GlobalDatabaseBrowser.this
								.getListSelectionListener());
				//				
				if (((DefaultTableModel) GlobalDatabaseBrowser.this.table
						.getModel()).getRowCount() < 1)
					GlobalDatabaseBrowser.this.tablebar
							.setText("No Matches Found");
			}
		};

		stop.addActionListener(new ActionListener() {

			@SuppressWarnings("deprecation")
			public void actionPerformed(final ActionEvent arg0) {

				GlobalDatabaseBrowser.this.t.stop();
				GlobalDatabaseBrowser.this.enable(true);
				searcher.close();
				((ListSelectionModel) GlobalDatabaseBrowser.this.table
						.getSelectionModel())
						.addListSelectionListener(GlobalDatabaseBrowser.this
								.getListSelectionListener());

				SwingUtilities.invokeLater(new Thread() {
					public void run() {
						dialog.dispose();
					}
				});

			}

		});

		this.enable(false);

		searcher.addSearchListener(new SearchListener() {

			int finishedrows = 0;

			// adding found matches to the table
			public void matchFound(final Vector<String> rowdata) {

				try {
					SwingUtilities.invokeAndWait(new Thread() {
						public void run() {
							((DefaultTableModel) GlobalDatabaseBrowser.this.table
									.getModel()).addRow(rowdata);
						}
					});
				} catch (final InterruptedException e) {
					e.printStackTrace();
				} catch (final InvocationTargetException e) {
					e.printStackTrace();
				}

				GlobalDatabaseBrowser.this.tablebar
						.setText(((DefaultTableModel) GlobalDatabaseBrowser.this.table
								.getModel()).getRowCount()
								+ " Matches found            "
								+ this.finishedrows + " compared Entries");
			}

			// updating the progressbar
			public void rowFinished(final int finishedIndex) {

				final int progress = (int) (finishedIndex * searcher.step);
				dialog.setProgress("Searching ( " + finishedIndex + " / "
						+ searcher.length + " )", progress, true);
				this.finishedrows = finishedIndex;
			}

		});
		searcher.setFile(this.contentsFile);

		dialog.setProgress("Determining Length", 0, true);

		((ListSelectionModel) this.table.getSelectionModel())
				.removeListSelectionListener(this);
		this.t.setPriority(CM2_CONSTANTS.THREADS.PRIORITY_SEARCH_THREAD);
		this.t.start();

	}

	/**
	 * Returns the implemented ListSelectionListener
	 * 
	 * @return
	 */
	private ListSelectionListener getListSelectionListener() {
		return this;
	}

	/**
	 * A modified ColumnSorter that treats the column with dates different; It
	 * sorts them by date, not alphabetic
	 * 
	 * @author Dingi dackelnose@gmx.net
	 * 
	 */
	private class MyColumnSorter extends ColumnSorter {

		public MyColumnSorter(final int colIndex, final boolean ascending) {
			super(colIndex, ascending);
		}

		public int compare(final Object a, final Object b) {
			final int returnvalue = super.compare(a, b);

			if (this.colIndex != 4)
				return returnvalue;

			final Vector objvectorA = (Vector) a;
			final Vector objvectorB = (Vector) b;
			Object objectA = objvectorA.get(this.colIndex);
			Object objectB = objvectorB.get(this.colIndex);

			// Treat empty strains like nulls
			if (objectA instanceof String && ((String) objectA).length() < 1) {
				objectA = null;
			}
			if (objectB instanceof String && ((String) objectB).length() < 1) {
				objectB = null;
			}
			/*
			 * Sort nulls so they appear last, regardless of sort order
			 */
			if (objectA == null && objectB == null) {
				return 0;
			} else if (objectA == null) {
				if (GlobalDatabaseBrowser.this.sortUpwards) {
					return 1;
				} else {
					return -1;
				}

			} else if (objectB == null) {
				if (GlobalDatabaseBrowser.this.sortUpwards) {
					return -1;
				} else {
					return 1;
				}
			}

			final SimpleDateFormat f = new SimpleDateFormat("ddMMyyyy");

			String stringA = ((String) objectA).replace("/", "");
			String stringB = ((String) objectB).replace("/", "");

			final int intA = Integer.parseInt(stringA.substring(stringA
					.length() - 2, stringA.length()));
			final int intB = Integer.parseInt(stringB.substring(stringB
					.length() - 2, stringB.length()));

			String yearA;
			if (intA < 10)
				yearA = "0" + intA;
			else
				yearA = "" + intA;

			String yearB;
			if (intB < 10)
				yearB = "0" + intB;
			else
				yearB = "" + intB;

			if (intA < 100 && intA > 70)
				stringA = stringA.substring(0, stringA.length() - 2) + "19"
						+ yearA;
			else
				stringA = stringA.substring(0, stringA.length() - 2) + "20"
						+ yearA;

			if (intB < 100 && intB > 70)
				stringB = stringB.substring(0, stringB.length() - 2) + "19"
						+ yearB;
			else
				stringB = stringB.substring(0, stringB.length() - 2) + "20"
						+ yearB;

			Date dA;
			try {
				dA = (Date) f.parseObject(stringA);
			} catch (final ParseException e) {
				if (GlobalDatabaseBrowser.this.sortUpwards) {
					return 1;
				} else {
					return -1;
				}
			}

			Date dB;
			try {
				dB = (Date) f.parseObject(stringB);
			} catch (final ParseException e) {
				if (GlobalDatabaseBrowser.this.sortUpwards) {
					return -1;
				} else {
					return 1;
				}
			}

			final boolean beforedB = dA.before(dB);

			if (GlobalDatabaseBrowser.this.sortUpwards && beforedB)
				return 1;
			else if (!GlobalDatabaseBrowser.this.sortUpwards && beforedB)
				return -1;
			else if (GlobalDatabaseBrowser.this.sortUpwards && !beforedB)
				return -1;
			else
				return 1;

		}

	}

	/**
	 * Creates a Customized JTable that shows the cell values in a tooltip
	 * 
	 * @author Dingi dackelnose@gmx.net
	 * 
	 */
	@SuppressWarnings("serial")
	private class MyJTable extends JTable {

		public Component prepareRenderer(final TableCellRenderer renderer,
				final int rowIndex, final int vColIndex) {
			final Component c = super.prepareRenderer(renderer, rowIndex,
					vColIndex);

			if (this.getValueAt(rowIndex, vColIndex) != null) {
				final JComponent jc = (JComponent) c;
				String tooltext = (String) this.getValueAt(rowIndex, vColIndex);

				// breaking string into lines for the tooltip
				int counter = 0;
				for (int i = 0; i < tooltext.length(); i++) {
					counter++;
					if (counter > 50 && tooltext.charAt(i) == ' ') {
						final String prefix = tooltext.substring(0, i);
						final String postfix = tooltext.substring(i);
						tooltext = prefix + "<br>" + postfix;
						counter = 0;
					}
				}

				tooltext = "<html>" + tooltext + "</html>";
				jc.setToolTipText(tooltext);

			} else {
				((JComponent) c).setToolTipText("");
			}

			return c;
		}

	}

	/**
	 * Literally downloads the passed URL.
	 * 
	 * @param dia
	 * @param url
	 *            the url to download from
	 * @param file
	 *            the file to download into
	 * @return true if sucessful, false otherwise
	 */
	private boolean downLoad(final StatusDialog dia, final URL url,
			final File file) {

		this.streamreader = null;
		this.filewriter = null;
		dia.setProgress("Establishing Connection...", 0, true);

		try {
			this.streamreader = new BufferedReader(new InputStreamReader(url
					.openStream()));
		} catch (final Throwable e) {
			JOptionPane
					.showMessageDialog(
							this.frame,
							"Problems occured while trying to establish connection to the following link:\n\n"
									+ url.toExternalForm()
									+ "\n\nReason:\n"
									+ e.toString(), "Connection Failed",
							JOptionPane.ERROR_MESSAGE);

			return false;
		}

		try {

			this.filewriter = new BufferedWriter(new FileWriter(file));
			this.readwrite(dia, file);

		} catch (final Throwable e) {
			JOptionPane.showMessageDialog(this.frame, "Cannot write the file\n"
					+ file.getPath() + "\n\nReason:\n" + e.toString(), "Error",
					JOptionPane.ERROR_MESSAGE);

			return false;
		}

		return true;

	}

	/**
	 * 
	 * Starts and handles downloading in another Thread
	 * @param opmDownload If true the PDB is downloaded from the OPM
	 * 	                  database, if false from the original PDB database
	 */
	private void performDownload(boolean opmDownload) {

		if ( (opmDownload && this.tf1.getText().length() < 1) || (!opmDownload && this.tf2.getText().length() < 1) )
			return;

		final URL url;
		try {
			url = new URL((opmDownload)?this.tf2.getText():this.tf1.getText());
		} catch (final MalformedURLException e1) {
			JOptionPane.showMessageDialog(this.frame, "The URL\n\n"
					+ ((opmDownload)?this.tf2.getText():this.tf1.getText()) + "\n\nis invalid!" + "\n\nReason:\n"
					+ e1.toString(), "Error", JOptionPane.ERROR_MESSAGE);
			return;
		}

		final int row = this.table.getSelectedRow();
		final Object code = ((DefaultTableModel) this.table.getModel())
				.getValueAt(row, 0);

		final File file = new File(this.tf3.getText() + File.separator + code +
				((opmDownload)?CM2_CONSTANTS.IO.OPM_FILENAME_ADDON:"")
				+ ".pdb");
		
		if (file.exists() || (!opmDownload && this.listener.dbContainsCode(code))  || 
				(opmDownload && this.listener.dbContainsCode(code+CM2_CONSTANTS.IO.OPM_FILENAME_ADDON))) {
			JOptionPane.showMessageDialog(this.frame,
					"You already have such a file!", "File already exists",
					JOptionPane.INFORMATION_MESSAGE);
			return;
		}

		final JButton cncl = new JButton("Cancel");
		final StatusDialog dia = new StatusDialog(cncl, false);

		final Thread t = new Thread() {
			public void run() {

				final boolean done = GlobalDatabaseBrowser.this.downLoad(dia,
						url, file);
				try {
					if (GlobalDatabaseBrowser.this.streamreader != null)
						GlobalDatabaseBrowser.this.streamreader.close();
					if (GlobalDatabaseBrowser.this.filewriter != null)
						GlobalDatabaseBrowser.this.filewriter.close();
				} catch (final IOException e) {
					e.printStackTrace();
				}

				dia.dispose();
				GlobalDatabaseBrowser.this.enable(true);
				if (done) {

					if (GlobalDatabaseBrowser.this.check1.isSelected()) {

						GlobalDatabaseBrowser.this.listener.addEntryToDB(file);

					}

				} else {

					file.delete();
				}
			}
		};

		cncl.addActionListener(new ActionListener() {

			@SuppressWarnings("deprecation")
			public void actionPerformed(final ActionEvent arg0) {

				t.stop();

				try {
					if (GlobalDatabaseBrowser.this.streamreader != null)
						GlobalDatabaseBrowser.this.streamreader.close();
					if (GlobalDatabaseBrowser.this.filewriter != null)
						GlobalDatabaseBrowser.this.filewriter.close();
				} catch (final IOException e) {
					e.printStackTrace();
				}

				file.delete();

				dia.dispose();
				GlobalDatabaseBrowser.this.enable(true);

			}

		});
		this.enable(false);
		t.setPriority(Thread.MIN_PRIORITY);
		t.start();

	}

	/**
	 * Performed when lists selection changes. Prepares the url to download
	 */
	public void valueChanged(final ListSelectionEvent e) {

		if (e.getValueIsAdjusting())
			return;

		final int row = this.table.getSelectedRow();
		if (row == -1)
			return;
		this.code = ((DefaultTableModel) this.table.getModel()).getValueAt(row,
				0);
		if (this.code == null)
			return;
		if (((String) this.code).length() < 1)
			return;

		final String string = this.rcsbDownloadLink.replaceAll("#PDBCODE#",
				(String) this.code);
		this.tf1.setText(string);
		this.tf1.setToolTipText(string);
		
		final String string2 = this.opmDownloadLink.replaceAll("#PDBCODE#",
				this.code.toString().toLowerCase());
		this.tf2.setText(string2);
		this.tf2.setToolTipText(string2);
		
		this.openBrowser.setEnabled(true);
		this.updateImage();

	}

	/**
	 * 
	 * @author Loads the preview image from the rcsb site and places it on the
	 *         label dackelnose@gmx.net
	 * 
	 */
	class ImageThread extends Thread {
		public InputStream str;

		public void run() {

			if (GlobalDatabaseBrowser.this.code == null) {
				GlobalDatabaseBrowser.this.piclabel.setIcon(null);
				return;
			} else {

				final URL url;
				try {
					url = new URL(DataPool.InternetSettings.rcsbimageLink
							.replaceAll("#PDBCODE#",
									((String) GlobalDatabaseBrowser.this.code)
											.toLowerCase()));
					this.str = url.openStream();
					final BufferedImage img = ImageIO.read(this.str);
					if (img != null) {
						final Image finalimage = img
								.getScaledInstance(
										GlobalDatabaseBrowser.this.piclabel
												.getSize().width,
										GlobalDatabaseBrowser.this.piclabel
												.getSize().height,
										BufferedImage.SCALE_DEFAULT);
						GlobalDatabaseBrowser.this.piclabel
								.setIcon(new ImageIcon(finalimage));
						this.str.close();
					}
				} catch (final Throwable e1) {
					GlobalDatabaseBrowser.this.piclabel.setIcon(null);
					try {
						this.str.close();
					} catch (final Throwable e) {

					}
					return;
				}

			}
		}

	};

	/**
	 * Updates the current previewimage using the imageThread
	 * 
	 */
	@SuppressWarnings("deprecation")
	private void updateImage() {
		if (this.imageThread != null) {
			if (this.imageThread.isAlive()) {
				this.imageThread.stop();
				try {
					if (this.imageThread != null
							&& this.imageThread.str != null)
						this.imageThread.str.close();
				} catch (final Throwable e) {

				}
			}
		}
		this.imageThread = new ImageThread();
		this.imageThread.start();

	}

	/**
	 * Update the information about the last modifications on the
	 * PDB, PDBTM and OPM file.
	 *
	 */
	private void updateLastModified() {

		try {
			
			final long lPDB = this.contentsFile.lastModified();
			final long lPDBTM = PPEUpdater.lastModified(PPE_CONSTANTS.DB.PDBTM);
			final long lOPM = PPEUpdater.lastModified(PPE_CONSTANTS.DB.OPM);
			long lastModified = 0;

			for(int i=0;i<3;i++) {
			
				switch(i) {
					case 0: lastModified=lPDB;break;
					case 1: lastModified=lPDBTM;break;
					case 2: lastModified=lOPM;break;
				}
				final Calendar cal = Calendar.getInstance();
				cal.setTimeInMillis(lastModified);
				String day = "" + cal.get(Calendar.DAY_OF_MONTH);
				String month = "" + (cal.get(Calendar.MONTH) + 1);
	
				if (day.length() < 2)
					day = "0" + day;
				if (month.length() < 2)
					month = "0" + month;
	
				String datestring = day + "." + month + "."
						+ cal.get(Calendar.YEAR);
				if (lastModified < 1)
					datestring = "-";
				
				switch(i) {
					case 0: this.l4.setText(datestring);break;
					case 1: this.l5.setText(datestring);break;
					case 2: this.l6.setText(datestring);break;
				}
				
			}

			
		} catch (final Exception e) {
			this.l4.setText("-");
		}

	}
	
}
